console.log("======== COMMAND LINE INTERFACE ========");


// ---- grid ----

console.log("  * grid -- print the grid in the console");

Object.defineProperty(window, "grid", {
    get: function() {
        var grid = game.grid;
        var result = "";
        for (var y=0 ; y<grid.length ; y++) {
            result += grid[y].join("\t") + "\n";
        }
        console.log(result + "----------------");
    },
    enumerable: true,
    configurable: false
});


// ---- speed ----

console.log("  * speed(n) -- change the game speed (fast: n=0, default: n=100)");

function speed(n) {
    SPEED = n;
}


// ---- batch ----

console.log("  * batch(n) -- generate statistics with n run of each IAs (default: n=10)");

function batch(n) {
    var n = n || 10;
    var _batchResult = {};
    var currentIA = -1;
    var run = 0;

    function _run() {
        if (game.gameStatus != game.GAME_STATUS_INGAME || currentIA < 0) {
            if (currentIA >= 0) {
                if (game.gameStatus == game.GAME_STATUS_WIN) {
                    _batchResult[IA[currentIA]._name].win++;
                    _batchResult[IA[currentIA]._name].winMove.push(Math.floor(SNAPSHOTS[SNAPSHOTS.length-1].data.length/2));
                }
                else {
                    _batchResult[IA[currentIA]._name].loose++;
                    _batchResult[IA[currentIA]._name].looseMove.push(Math.floor(SNAPSHOTS[SNAPSHOTS.length-1].data.length/2));
                }
                var grid = SNAPSHOTS[SNAPSHOTS.length-1].data[SNAPSHOTS[SNAPSHOTS.length-1].data.length-1];
                for (var y=0 ; y<4 ; y++) {
                    for (var x=0 ; x<4 ; x++) {
                        if (grid[y][x] > _batchResult[IA[currentIA]._name].bestTile) {
                            _batchResult[IA[currentIA]._name].bestTile = grid[y][x];
                        }
                    }
                }
            }
            if (currentIA < 0 || run == n) {
                currentIA += 1;
                run = 0;
                if (currentIA < IA.length) {
                    _batchResult[IA[currentIA]._name] = {
                        win: 0,
                        loose: 0,
                        winMove: [],
                        looseMove: [],
                        bestTile: 2
                    }
                }
            }
            if (currentIA < IA.length) {
                IA[currentIA].play();
                run += 1;
            }
        }
        if (currentIA < IA.length || currentIA == IA.length-1 && run < n) {
            setTimeout(_run, 100);
        }
        else {
            //console.log(window.stat=_batchResult); //FIXME
            new Stat("Batch ×" + n, _batchResult);
            speed(100);
        }
    }

    speed(0);
    _run();
}


// ---- batch ----

console.log("  * snapshot -- take a snapshot of the current game");

Object.defineProperty(window, "snapshot", {
    get: function() {
        new Snapshot("Player Snapshot", game.snapshots);
    },
    enumerable: true,
    configurable: false
});

console.log("========================================\n");
