// Yes, we can play to 2048 with a gamepad too...
// NOTE: this is just a test, the gamepad is configured for a Xbox 360 Gamepad under Linux.

var Gamepad = $Class.$extend({

    _gamepad: null,
    _buttons: [
        {section: "buttons", threshold: 1, button: 12, callback: game.moveUp.bind(game)},
        {section: "buttons", threshold: 1, button: 13, callback: game.moveDown.bind(game)},
        {section: "buttons", threshold: 1, button: 14, callback: game.moveLeft.bind(game)},
        {section: "buttons", threshold: 1, button: 15, callback: game.moveRight.bind(game)},

        {section: "axes", threshold: -.85, button: 1, callback: game.moveUp.bind(game)},
        {section: "axes", threshold: .85, button: 1, callback: game.moveDown.bind(game)},
        {section: "axes", threshold: -.85, button: 0, callback: game.moveLeft.bind(game)},
        {section: "axes", threshold: .85, button: 0, callback: game.moveRight.bind(game)},

        {section: "buttons", threshold: 1, button: 16, callback: game.newGame.bind(game)},
        {section: "buttons", threshold: 1, button: 9, callback: function(){snapshot;}},
    ],

    __init__: function() {
        this.$super();
        this.__gamepadLoop();
    },

    _getGamepads: function() {
        if (navigator.getGamepads) return navigator.getGamepads();
        if (navigator.mozGetGamepads) return navigator.mozGetGamepads();
        if (navigator.webkitGetGamepads) return navigator.webkitGetGamepads();
    },

    __gamepadLoop: function() {
        var gp = this._getGamepads();
        if (gp[0]) {
            if (!this._gamepad) {
                console.info("Gamepad conneced.");
                this._gamepad = gp[0];
            }
        }
        else {
            if (this._gamepad) {
                console.info("Gamepad disconneced.");
            }
            this._gamepad = null;
            this._configured = false;
            setTimeout(this.__gamepadLoop.bind(this), 50);
            return;
        }

        for (var i=0 ; i<this._buttons.length ; i++) {
            var b = this._buttons[i];
            var v = this._gamepad[b.section][b.button];
            if (b.threshold > 0 && v >= b.threshold || b.threshold < 0 && v <= b.threshold) {
                b.callback();
                setTimeout(this.__gamepadLoop.bind(this), 150);
                return;
            }
        }

        setTimeout(this.__gamepadLoop.bind(this), 50);
    }
});

new Gamepad();
