var IA = [];
var e_iaBtn = document.getElementById("ia-btn");
var SPEED = 100;


function gridCopy(grid) {
    var result = [];
    for (var y = 0; y < grid.length; y++) {
        result.push([]);
        for (var x = 0; x < grid[y].length; x++) {
            result[y].push(grid[y][x]);
        }
    }
    return result;
}


var BaseIA = $Class.$extend({

    MOVES: [
        {name: "moveUp", dx: 0, dy: -1},
        {name: "moveDown", dx: 0, dy: 1},
        {name: "moveLeft", dx: -1, dy: 0},
        {name: "moveRight", dx: 1, dy: 0}
    ],

    _name: "Base IA",

    _element: null,
    _snapshots: null,

    __init__: function() {
        this.$super();
        this._element = document.createElement("button");
        this._element.appendChild(document.createTextNode(this._name));
        this._element.addEventListener("click", this.play.bind(this), false);
        e_iaBtn.appendChild(this._element);
        IA.push(this);
    },

    play: function() {
        game.newGame();
    },

    loop: function(callback) {
        callback();
        if (game.gameStatus == game.GAME_STATUS_INGAME) {
            setTimeout(this.loop.bind(this, callback), SPEED);
        }
        //else if (game.gameStatus == game.GAME_STATUS_WIN) {
        else {
            new Snapshot("Snapshot: " + this._name, game.snapshots, game.gameStatus == game.GAME_STATUS_WIN);
        }
    },

    simulate: function(dx, dy, grid) {
        var moves = 0;
        var points = 0;

        var grid = (grid !== undefined) ? gridCopy(grid) : game.grid;
        var mask = [
            [false, false, false, false],
            [false, false, false, false],
            [false, false, false, false],
            [false, false, false, false]
        ];
        var nx = 0;
        var ny = 0;
        var tx = 0;
        var ty = 0;

        for (var y = ((dy < 0) ? 0 : 3); ((dy < 0) ? y <= 3 : y >= 0); y -= dy || 1) {
            for (var x = ((dx < 0) ? 0 : 3); ((dx < 0) ? x <= 3 : x >= 0); x -= dx || 1) {

                if (grid[y][x] == 0) {
                    continue;
                }

                tx = x;
                ty = y

                for (var n = 1; n <= 3; n++) {
                    nx = Math.min(3, Math.max(0, x + n * dx));
                    ny = Math.min(3, Math.max(0, y + n * dy));

                    if (nx == tx && ny == ty) {
                        break;
                    }

                    if (grid[ny][nx] == 0) {
                        moves++;
                        grid[ny][nx] = grid[ty][tx];
                        grid[ty][tx] = 0;
                        tx = nx;
                        ty = ny;
                    }
                    else if (!mask[ny][nx] && grid[ny][nx] == grid[ty][tx]) {
                        moves++;
                        points += grid[ty][tx];
                        grid[ny][nx] = 0;
                        grid[ty][tx] *= 2;
                        mask[ny][nx] = true;
                        grid[ny][nx] = grid[ty][tx];
                        grid[ty][tx] = 0;
                        tx = nx;
                        ty = ny;
                        break;
                    }
                    else {
                        break;
                    }
                }

            }
        }

        return {points: points, moves: moves, grid: grid};
    },

    getEmptyCells: function(grid) {
        var result = [];
        var grid = grid;

        for (var y = 0; y < 4; y++) {
            for (var x = 0; x < 4; x++) {
                if (grid[y][x] == 0) {
                    result.push({x: x, y: y});
                }
            }
        }

        return result;
    }

});
