var CarssoIA = BaseIA.$extend({

    _name: "Carsso IA",


    search: function (grid) {
        var bestScore = -10;
        var bestMove = -1;
        var results = [];
        for (var i = 0 in this.MOVES) {
            var searchResult = this.simulate(this.MOVES[i].dx, this.MOVES[i].dy, grid);
            var score = 0;
            if (searchResult.moves > 0) {
                score++;
                score = score+parseInt(searchResult.points);
                var newGrid = searchResult.grid;
                var grids = this.genNextGrids(newGrid);
                for (var grid2 in grids.grids) {
                    for (var j = 0 in this.MOVES) {
                        var searchResult2 = this.simulate(this.MOVES[j].dx, this.MOVES[j].dy, grids.grids[grid2]);
                        if (searchResult2.moves > 0) {
                            score = score+parseInt(searchResult2.points);
                        }
                    }
                }
            }
            results[i] = score;
        }
        //console.log(results);
        for (var i = 0 in results) {
            if (results[i] >= bestScore) {
                bestScore = results[i];
                bestMove = i;
            }
        }
        //console.log(this.MOVES[bestMove].name);
        //console.log(bestScore);

        return {move: bestMove, score: bestScore};
    },

    genNextGrids: function (grid) {
        var grids = [];
        var nbGrids = 0;
        var possibleValues = [2, 4];
        for (possibleValue in possibleValues) {
            for (var i = 0; i < grid.length; i++) {
                for (var j = 0; j < grid[i].length; j++) {
                    if (grid[i][j] == 0) {
                        var tempGrid = grid;
                        tempGrid[i][j] = possibleValue;
                        grids.push(tempGrid);
                        nbGrids++;
                    }
                }
            }
        }
        return {nbGrids: nbGrids, grids: grids};
    },

    play: function () {
        this.$super();
        this.loop(function () {
            var grid = game.grid;
            var result = this.search(grid);
            if (result.move == -1) {
                game.gameStatus = game.GAME_STATUS_LOOSE;
                console.log('ERROR with AI !')
            } else {
                game[this.MOVES[result.move].name]();
            }

        }.bind(this));
    },

    debugGrid: function (grid) {
        for (var y = 0; y < grid.length; y++) {
            console.log(grid[y].join("\t"));
        }
        console.log("----------------");
    }

});

new CarssoIA();
