var FlozzIA = BaseIA.$extend({

    _name: "FLOZz IA",

    _maxDepth: 2,

    _smoothness: function(grid) {
        var values = [0, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096];
        var result = 0;
        var tiles = [];

        for (var y=0 ; y<4 ; y++) {
            for (var x=0 ; x<4 ; x++) {
                if (x < 3) result += Math.abs(values.indexOf(grid[y][x]) - values.indexOf(grid[y][x+1]));
                if (y < 3) result += Math.abs(values.indexOf(grid[y][x]) - values.indexOf(grid[y+1][x]));
                if (tiles.length == 0 || tiles[0].value == grid[y][x]) {
                    tiles.push({value: grid[y][x], x: x, y: y});
                }
                else if (tiles.length > 0 && tiles[0].value < grid[y][x]) {
                    tiles = [{value: grid[y][x], x: x, y: y}];
                }
            }
        }

        tiles.sort(function(a, b) {
            var ca = (a.x == 0 && a.y == 0 || a.x == 3 && a.y == 0 || a.x == 0 && a.y == 3 || a.x == 3 && a.y == 3);
            var cb = (b.x == 0 && b.y == 0 || b.x == 3 && b.y == 0 || b.x == 0 && b.y == 3 || b.x == 3 && b.y == 3);
            if (a && b) {
                return 0;// TODO
            }
            else if (a) return -1;
            else if (b) return 1;
            return 0;
        });

        if (tiles.length) {
            if (tiles[0].x == 1 || tiles[0].x == 2) result *= 1.5;
            if (tiles[0].y == 1 || tiles[0].y == 2) result *= 1.5;
        }

        return result;
    },

    _findNextMove: function(grid, depth) {
        var grid = grid && gridCopy(grid) || game.grid;
        var depth = (depth !== undefined) ? depth-1 : this._maxDepth;
        var result = null;

        var r = null;
        var rr = null;
        for (var m=0 ; m<this.MOVES.length ; m++) {
            r = this.simulate(this.MOVES[m].dx, this.MOVES[m].dy, grid);
            r.direction = m;
            r.empty = this.getEmptyCells(r.grid).length;
            r.smoothness = this._smoothness(r.grid);
            r.value = 1/r.smoothness * r.empty;

            if (!r.moves) continue;

            if (depth) {
                rr = this._findNextMove(r.grid, depth);
                r.points += rr.points;
                r.value += rr.value;
            }

            if (!result || result.value < r.value) {
                result = r;
            }
        }

        return result;
    },

    play: function () {
        this.$super()

        this.loop(function () {
            var result = this._findNextMove();
            game[this.MOVES[result.direction].name]();
        }.bind(this));
    }

});

new FlozzIA();
