var Flozz2IA = BaseIA.$extend({

    _name: "FLOZz² IA",

    _maxDepth: 2,

    _smoothness: function(grid) {
        var values = [0, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096];
        var result = 0;
        var tiles = [];
        var max = null;

        for (var y=0 ; y<4 ; y++) {
            for (var x=0 ; x<4 ; x++) {
                if (!max || max.value < grid[y][x]) {
                    max = {value: grid[y][x], x: x, y: y};
                }
            }
        }

        var dx = -1;
        if (max.x > 1) dx = 1;
        var dy = -1;
        if (max.y > 1) dy = 1;

        var ddx = 0;
        var ddy = 0;
        for (var y=0 ; y<4 ; y++) {
            for (var x=0 ; x<4 ; x++) {
                if (dx < 0) ddx = (x < 3) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y][x+1]) : 0;
                else ddx = (x > 0) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y][x-1]) : 0;

                if (ddx > 0) result += ddx;
                else if (ddx < 0) result -= 10 * ddx;

                if (dy < 0) ddy = (y < 3) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y+1][x]) : 0;
                else ddy = (y > 0) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y-1][x]) : 0;

                if (ddy > 0) result += ddy;
                else if (ddy < 0) result -= 10 * ddy;

                if (tiles.length == 0 || tiles[0].value == grid[y][x]) {
                    tiles.push({value: grid[y][x], x: x, y: y});
                }
                else if (tiles.length > 0 && tiles[0].value < grid[y][x]) {
                    tiles = [{value: grid[y][x], x: x, y: y}];
                }
            }
        }

        tiles.sort(function(a, b) {
            var ca = (a.x == 0 && a.y == 0 || a.x == 3 && a.y == 0 || a.x == 0 && a.y == 3 || a.x == 3 && a.y == 3);
            var cb = (b.x == 0 && b.y == 0 || b.x == 3 && b.y == 0 || b.x == 0 && b.y == 3 || b.x == 3 && b.y == 3);
            if (a && b) {
                return 0;// TODO
            }
            else if (a) return -1;
            else if (b) return 1;
            return 0;
        });

        if (tiles.length) {
            if (tiles[0].x == 1 || tiles[0].x == 2) result *= 1.5;
            if (tiles[0].y == 1 || tiles[0].y == 2) result *= 1.5;
        }

        return result;
    },

    _findNextMove: function(grid, depth) {
        var grid = grid && gridCopy(grid) || game.grid;
        var depth = (depth !== undefined) ? depth-1 : this._maxDepth;
        var result = null;

        var r = null;
        var rr = null;
        for (var m=0 ; m<this.MOVES.length ; m++) {
            r = this.simulate(this.MOVES[m].dx, this.MOVES[m].dy, grid);
            r.direction = m;
            r.empty = this.getEmptyCells(r.grid).length;
            r.smoothness = this._smoothness(r.grid);
            r.value = r.empty / r.smoothness;

            if (!r.moves) continue;

            if (depth) {
                rr = this._findNextMove(r.grid, depth);
                r.points += rr.points;
                r.value += rr.value;
            }

            if (!result || result.value < r.value) {
                result = r;
            }
            else if (result.value == r.value) {
                //if (result.empty < r.empty) result = r;
                //else if (result.points < r.points) result = r;
            }
        }

        return result;
    },

    play: function () {
        this.$super()

        this.loop(function () {
            var result = this._findNextMove();
            game[this.MOVES[result.direction].name]();
        }.bind(this));
    }

});

new Flozz2IA();
