var MorsiIA = BaseIA.$extend({

    _name: "Morsi IA",

    play: function() {
        this.$super();

        this.loop(function () {
            var result = this.findNextMove();
            game[result.name]();
        }.bind(this));
    },
    
    analyseGamePhase: function(grid) {
        var phase = null;
        var value = {};
        for (var y=0 ; y<4 ; y++) {
            for (var x=0 ; x<4 ; x++) {
                if (grid[y][x] < 8){
                    continue;
                }
                if (value[grid[y][x]] ){
                    value[grid[y][x]]++;
                }else {
                    value[grid[y][x]] = 1;
                }
            }
        }
        
        for (var i in value) {
            if (value[i] >= 3){
                phase = "merge";
                break;
            }
        }
        
        return phase;
    },
    
    analyse: function(grid) {
        var values = [0, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096];
        var intel = 0;
        var max = null;
        var phase = this.analyseGamePhase(grid);

        for (var y=0 ; y<4 ; y++) {
            for (var x=0 ; x<4 ; x++) {
                if (!max|| max[0].value < grid[y][x]) {
                    max = [{value: grid[y][x], x: x, y: y}];
                } else if ( max[0].value == grid[y][x]) {
                    max.push({value: grid[y][x], x: x, y: y});
                }
            }
        }
        
        max.sort(function(a, b) {
            var va = 0;
            var vb = 0;
            if (a.x == 1 || a.x == 2){
                va++;
            }
            if (a.y == 1 || a.y == 2){
                va++;
            }
            if (b.x == 1 || b.x == 2){
                vb++;
            }
            if (a.y == 1 || a.y == 2){
                vb++;
            }
            if (a < b){
                return -1; 
            }
            if (a > b){
                return 1;
            }
            return 0;
        });
        
        var dx = -1;
        if (max[0].x > 1) dx = 1;
        var dy = -1;
        if (max[0].y > 1) dy = 1;

        var ddx = 0;
        var ddy = 0;
        
        if (phase = "merge"){
            intel = this.getEmptyCells(grid).length;
        } 
        
        for (var y=0 ; y<4 ; y++) {
            for (var x=0 ; x<4 ; x++) {
                if (dx < 0) ddx = (x < 3) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y][x+1]) : 0;
                else ddx = (x > 0) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y][x-1]) : 0;

                if (ddx > 0) intel -= ddx;
                else if (ddx < 0) intel += 10 * ddx;

                if (dy < 0) ddy = (y < 3) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y+1][x]) : 0;
                else ddy = (y > 0) ? values.indexOf(grid[y][x]) - values.indexOf(grid[y-1][x]) : 0;

                if (ddy > 0) intel -= ddy;
                else if (ddy < 0) intel += 10 * ddy;
            }
        }
        
        /*for (i = 0; i < max.length; i++){
            if (max[i].x == 2 || max[i].x == 1){
                if (phase = "merge"){
                    intel -= 2;
                } else {
                    intel -= 1;
                }
            } 
            if (max[i].y == 2 || max[i].y == 1){
                if (phase = "merge"){
                    intel -= 2;
                } else {
                    intel -= 1;
                }
            }
        }*/
    
        return intel;
    },
    
    findNextMove: function (stop) {
        var result = [];
        for (var i = 0; i < this.MOVES.length; i++) {
            var s = this.simulate(this.MOVES[i].dx, this.MOVES[i].dy);
            if (s.moves > 0) {
                result.push({
                    name: this.MOVES[i].name,
                    intel: this.analyse(s.grid)
                });
                if (!stop){
                    var r = this.findNextMove(true);
                    result[result.length-1].intel += r.intel;
                }
            }
        }
        result.sort(function(a,b) {
            if (a.intel < b.intel) {
                return 1;
            } else if (a.intel > b.intel) {
                return -1;
            }
            return 0;
        });
        
        return result[0];
    }
});

new MorsiIA();
