var SNAPSHOTS = [];
var e_snapshotBtn = document.getElementById("snapshot-btn");
var e_snapshotPreview = document.getElementById("snapshot-preview");

var Snapshot = $Class.$extend({

    name: "Unnamed Snapshot",
    data: null,
    win: false,

    _element: null,

    __init__: function(name, data, win) {
        this.name = name || this.name;
        this.data = data || null;
        this.win = win || false;

        this._element = document.createElement("button");
        this._element.appendChild(document.createTextNode(this.name));
        this._element.className = (this.win) ? "party-win" : "party-loose";
        this._element.addEventListener("click", this.showSnapshot.bind(this), false);
        e_snapshotBtn.appendChild(this._element);
        SNAPSHOTS.push(this);
    },

    showSnapshot: function() {
        var frag = document.createDocumentFragment();

        var button = document.createElement("button");
        button.appendChild(document.createTextNode("Close"));
        button.onclick = function() {
           e_snapshotPreview.style.display = "none";
        }
        frag.appendChild(button);

        var title = document.createElement("h1");
        title.appendChild(document.createTextNode(this.name + " (" + Math.floor(this.data.length/2) + " moves)"));
        frag.appendChild(title);

        var table = null;
        var tr = null;
        var td = null;
        for (var i=0 ; i<this.data.length ; i++) {
            table = document.createElement("table");
            for (var y=0 ; y<4 ; y++) {
                tr = document.createElement("tr");
                for (var x=0 ; x<4 ; x++) {
                    td = document.createElement("td");
                    td.appendChild(document.createTextNode(this.data[i][y][x]));
                    td.className = "tile-style-" + this.data[i][y][x];
                    tr.appendChild(td);
                }
                table.appendChild(tr);
            }
            frag.appendChild(table);
        }

       e_snapshotPreview.innerHTML = "";  // Dirty but fast
       e_snapshotPreview.appendChild(frag);
       e_snapshotPreview.style.display = "block";
    }

});
