var STATS = [];
var e_statBtn = document.getElementById("stat-btn");
var e_statPreview = document.getElementById("stat-preview");

var Stat = $Class.$extend({

    name: "Unnamed Stat",
    data: null,

    _element: null,

    __init__: function(name, data) {
        this.name = name || this.name;
        this.data = data || null;

        this._element = document.createElement("button");
        this._element.appendChild(document.createTextNode(this.name));
        this._element.addEventListener("click", this.showStat.bind(this), false);
        e_statBtn.appendChild(this._element);
        STATS.push(this);
    },

    showStat: function() {
        var nbruns = 0;
        for (var ia in this.data) {
            nbruns = this.data[ia].win + this.data[ia].loose;
            break;
        }

        var frag = document.createDocumentFragment();

        var button = document.createElement("button");
        button.appendChild(document.createTextNode("Close"));
        button.onclick = function() {
           e_statPreview.style.display = "none";
        }
        frag.appendChild(button);

        var title = document.createElement("h1");
        title.appendChild(document.createTextNode(this.name));
        frag.appendChild(title);

        // ==== Win ratio

        var data = [];
        var legend = [];
        for (var ia in this.data) {
            var p = Math.round(this.data[ia].win/nbruns*100);
            data.push(p);
            legend.push(ia + " (" + p + "%)");
        }

        frag.appendChild(this._barChart(data, legend, "IAs win ratio", true));

        // ==== Max tile

        var data = [];
        var legend = [];
        for (var ia in this.data) {
            var p = Math.round(this.data[ia].bestTile/2048*100);
            data.push(p);
            legend.push(ia + " (" + this.data[ia].bestTile + ")");
        }

        frag.appendChild(this._barChart(data, legend, "Best Tile", true));

        // ==== IA specific

        for (var ia in this.data) {
            var title = document.createElement("h2");
            title.appendChild(document.createTextNode(ia));
            frag.appendChild(title);

            var legend = [
                "0-99", "100-199", "200-299", "300-399", "400-499",
                "500-599", "600-699", "700-799", "800-899", "900-999",
                "1000-1099", "1100-1199", "1200-1299", "1300-1399", "1400-1499"
            ];
            var wdata = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
            var ldata = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

            // Win

            for (var j=0 ; j<this.data[ia].winMove.length ; j++) {
                wdata[Math.floor(this.data[ia].winMove[j]/100)] += 1;
            }

            if (this.data[ia].winMove.length) {
                for (var j=0 ; j<wdata.length ; j++) {
                    wdata[j] = Math.round(wdata[j]/this.data[ia].winMove.length*100);
                }
            }

            var table = this._barChart(wdata, legend, "Moves (win)", false);
            table.className += " slim";
            frag.appendChild(table);

            // Loose

            for (var j=0 ; j<this.data[ia].looseMove.length ; j++) {
                ldata[Math.floor(this.data[ia].looseMove[j]/100)] += 1;
            }

            if (this.data[ia].looseMove.length) {
                for (var j=0 ; j<ldata.length ; j++) {
                    ldata[j] = Math.round(ldata[j]/this.data[ia].looseMove.length*100);
                }
            }

            var table = this._barChart(ldata, legend, "Moves (loose)", false);
            table.className += " slim";
            frag.appendChild(table);


            var p = Math.round(this.data[ia].win/nbruns*100);
            data.push(p);
            legend.push(ia + " (" + p + "%)");
        }

        //

        e_statPreview.innerHTML = "";  // Dirty but fast
        e_statPreview.appendChild(frag);
        e_statPreview.style.display = "block";
    },

    _barChart: function(data, legend, title, color) {
        var table = document.createElement("table");
        table.className = "chart chart-bar" + ((color) ? " color" : "");

        var tr = null;
        var e = null;
        var ee = null;

        if (title) {
            tr = document.createElement("tr");

            e = document.createElement("th");
            e.appendChild(document.createTextNode(title));
            e.colSpan = "2";
            tr.appendChild(e);

            table.appendChild(tr);
        }

        for (var i=0 ; i<data.length ; i++) {
            tr = document.createElement("tr");
            tr.className = "data";

            e = document.createElement("td");
            e.appendChild(document.createTextNode(legend[i]));
            tr.appendChild(e);

            e = document.createElement("td");
            ee = document.createElement("div");
            ee.className = "chart-bar-bar";
            ee.style.width = data[i] + "%";
            e.appendChild(ee);
            tr.appendChild(e);

            table.appendChild(tr);
        }

        return table;
    }

});


//(new Stat("TEST STAT", {
    //"Dummy IA": {
        //"win": 0,
        //"loose": 3,
        //"winMove": [],
        //"looseMove": [134, 134, 116],
        //"bestTile": 128
    //},
    //"Simple IA": {
        //"win": 0,
        //"loose": 3,
        //"winMove": [],
        //"looseMove": [170, 113, 64],
        //"bestTile": 256
    //},
    //"Carsso IA": {
        //"win": 0,
        //"loose": 3,
        //"winMove": [],
        //"looseMove": [385, 379, 230],
        //"bestTile": 512
    //},
    //"FLOZz IA": {
        //"win": 2,
        //"loose": 1,
        //"winMove": [902, 843],
        //"looseMove": [752],
        //"bestTile": 2048
    //},
    //"FLOZz² IA": {
        //"win": 3,
        //"loose": 0,
        //"winMove": [897, 844, 872],
        //"looseMove": [],
        //"bestTile": 2048
    //}
//})).showStat();
